package com.htfp.weather.web.controller;

import com.htfp.weather.web.exception.AppExcpetion;
import com.htfp.weather.web.exception.ErrorCode;
import com.htfp.weather.web.pojo.response.Result;
import org.springframework.validation.BindException;
import org.springframework.validation.ObjectError;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

/**
 * @Author : shiyi
 * @Date : 2024/3/14 16:28
 * @Description : 校验异常捕获
 */
@RestControllerAdvice
public class ControllerExceptionAdvice {

    @ExceptionHandler({BindException.class})
    public Result methodArgumentNotValidExceptionHandler(BindException e) {
        // 从异常对象中拿到ObjectError对象
        ObjectError objectError = e.getBindingResult().getAllErrors().get(0);
        return Result.error(ErrorCode.VALIDATE_ERROR, objectError.getDefaultMessage());
    }

    // @ExceptionHandler({Exception.class})
    // public Result otherExceptionHandler(Exception e) {
    //     return Result.error(e);
    // }

    @ExceptionHandler({AppExcpetion.class})
    public Result appExceptionHandler(AppExcpetion e) {
        return Result.error(e.getErrorCode(), e.getMessage());
    }
}