package com.htfp.weather.utils;


import org.junit.jupiter.api.Test;

import java.time.OffsetDateTime;
import java.time.ZoneOffset;
import java.time.format.DateTimeFormatter;

/**
 * @Author : shiyi
 * @Date : 2024/1/24 9:07
 * @Description :
 */
class DateTimeUtilsTest {

    @Test
    void convertZonedDateTime() {
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd'T'HH:mm:ssXXX");

        String timeZoneString = "2024-01-23T11:00:00+00:00";
        // 使用 OffsetDateTime 的 parse() 方法，将时区字符串转换为 OffsetDateTime 对象，表示东八区时区的 2024-01-23T11:00+08:00
        OffsetDateTime offsetDateTime = OffsetDateTime.parse(timeZoneString, formatter);

        // 使用 OffsetDateTime 的 withOffsetSameInstant() 方法，将东八区时区转换为0时区
        OffsetDateTime utc = offsetDateTime.withOffsetSameInstant(ZoneOffset.ofHours(8));

        // 使用 OffsetDateTime 的 format() 方法，将 OffsetDateTime 对象转换为字符串
        String utcStr = utc.format(formatter);

        // 打印结果
        System.out.println("input: " + timeZoneString);
        System.out.println("output: " + utc);
    }

    @Test
    void getBJTDateTimeFromUTC() {
        String timeZoneString = "2024-01-23T11:00";
        System.out.println(DateTimeUtils.getBJTDateTimeStringFromUTC(timeZoneString, "yyyy-MM-dd'T'HH:mm"));
    }

    @Test
    void getTimestampMillli() {
        long utc20230701 = DateTimeUtils.getTimestampMilli("UTC20230701", "'UTC-'yyyyMMdd");
        System.out.println(utc20230701);
    }


}