package com.htfp.weather.utils;

import org.junit.jupiter.api.Test;

import java.util.Arrays;
import java.util.List;

import static com.htfp.weather.utils.NdArrayUtils.findNearestIndex;
import static org.junit.jupiter.api.Assertions.*;
/**
* @Author : shiyi
* @Date : 2024/5/10 11:49
* @Description :
*/class NdArrayUtilsTest {

    @Test
    public void testEmptyList() {
        double[] list = new double[] {};
        double target = 3.5;
        int expected = -1;
        int result = findNearestIndex(list, target);
        assertEquals(expected, result);
    }

    @Test
    public void testSingleElementList() {
        double[] list = new double[] {1.0};
        double target = 3.5;
        int expected = 0;
        int result = findNearestIndex(list, target);
        assertEquals(expected, result);
    }

    @Test
    public void testThreeElementList() {
        double[] list = new double[] {1.0, 2.0, 3.0};
        double target = 2.4;
        int expected = 1;
        int result = findNearestIndex(list, target);
        assertEquals(expected, result);
    }

    @Test
    public void testFiveElementList() {
        double[] list = new double[] {1.0, 2.0, 3.0, 4.0, 5.0};
        double target = 3.5;
        int expected = 2;
        int result = findNearestIndex(list, target);
        assertEquals(expected, result);
    }

    @Test
    public void testTenElementList() {
        double[] list = new double[] {1.0, 2.0, 3.0, 4.0, 5.0, 6.0, 7.0, 8.0, 9.0, 10.0};
        double target = 5.5;
        int expected = 4;
        int result = findNearestIndex(list, target);
        assertEquals(expected, result);
    }

    @Test
    public void testStepElementList() {
        double[] list = new double[] {1.0, 1.0, 2.0, 2.0, 3.0, 4.0, 4.0, 5.0, 6.0, 7.0};
        double target = 1.7;
        int expected = 2;
        int result = findNearestIndex(list, target);
        assertEquals(expected, result);
    }

    @Test
    public void testLongElementList() {
        double[] list = new double[1000] ;
        for (int i = 0; i < list.length; i++) {
            list[i] = 0 + i*0.025;
        }
        double target = 18.524;
        int expected = 741;
        int result = findNearestIndex(list, target);
        assertEquals(expected, result);
        System.out.println("result:" + list[expected]);
    }
}